summaryrefslogtreecommitdiffstats
path: root/system
diff options
context:
space:
mode:
author Vasco Santos2018-09-14 13:12:39 +0200
committer David Spencer2018-09-14 13:12:39 +0200
commitaaf774846c5cce37448331f586e1cc1b0153306c (patch)
treeafa399882189ba5b6112a6f971b7e92f273a9bc8 /system
parent94f25f1301d0a07d7e92fd6b08e5df1d4cff852d (diff)
downloadslackbuilds-aaf774846c5cce37448331f586e1cc1b0153306c.tar.gz
system/lxd: Added (container hypervisor for lxc).
Signed-off-by: David Spencer <idlemoor@slackbuilds.org>
Diffstat (limited to 'system')
-rw-r--r--system/lxd/README3
-rw-r--r--system/lxd/doinst.sh29
-rw-r--r--system/lxd/etc-profile-d-lxd.csh3
-rw-r--r--system/lxd/etc-profile-d-lxd.sh3
-rw-r--r--system/lxd/lxd.SlackBuild92
-rw-r--r--system/lxd/lxd.info10
-rw-r--r--system/lxd/service-log-lxd-run43
-rw-r--r--system/lxd/service-lxd-run55
-rw-r--r--system/lxd/slack-desc19
9 files changed, 257 insertions, 0 deletions
diff --git a/system/lxd/README b/system/lxd/README
new file mode 100644
index 0000000000..0a65c51c86
--- /dev/null
+++ b/system/lxd/README
@@ -0,0 +1,3 @@
+LXD is a container "hypervisor" and a new user experience for LXC.
+
+This package includes scripts to run the lxd service under DJB daemontools.
diff --git a/system/lxd/doinst.sh b/system/lxd/doinst.sh
new file mode 100644
index 0000000000..0b95a44d98
--- /dev/null
+++ b/system/lxd/doinst.sh
@@ -0,0 +1,29 @@
+config() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ # If there's no config file by that name, mv it over:
+ if [ ! -r $OLD ]; then
+ mv $NEW $OLD
+ elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
+ # toss the redundant copy
+ rm $NEW
+ fi
+ # Otherwise, we leave the .new copy for the admin to consider...
+}
+
+preserve_perms() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ if [ -e $OLD ]; then
+ cp -a $OLD ${NEW}.incoming
+ cat $NEW > ${NEW}.incoming
+ mv ${NEW}.incoming $NEW
+ fi
+ config $NEW
+}
+
+preserve_perms etc/profile.d/lxd.sh.new
+preserve_perms etc/profile.d/lxd.csh.new
+
+config opt/lxd/service/run.new
+config opt/lxd/service/log/run.new
diff --git a/system/lxd/etc-profile-d-lxd.csh b/system/lxd/etc-profile-d-lxd.csh
new file mode 100644
index 0000000000..01bead2ead
--- /dev/null
+++ b/system/lxd/etc-profile-d-lxd.csh
@@ -0,0 +1,3 @@
+#!/bin/csh
+setenv LXD_HOME /opt/lxd
+setenv PATH ${LXD_HOME}/bin:${PATH}
diff --git a/system/lxd/etc-profile-d-lxd.sh b/system/lxd/etc-profile-d-lxd.sh
new file mode 100644
index 0000000000..3b9034b1ce
--- /dev/null
+++ b/system/lxd/etc-profile-d-lxd.sh
@@ -0,0 +1,3 @@
+#!/bin/sh
+export LXD_HOME=/opt/lxd
+export PATH=${LXD_HOME}/bin:${PATH}
diff --git a/system/lxd/lxd.SlackBuild b/system/lxd/lxd.SlackBuild
new file mode 100644
index 0000000000..d9eb9a658e
--- /dev/null
+++ b/system/lxd/lxd.SlackBuild
@@ -0,0 +1,92 @@
+#!/bin/sh
+
+# Slackware build script for lxd
+
+# Copyright 2017-2018 Vasco Santos <valexsantos[at]gmail[dot]com>
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ''AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=lxd
+VERSION=${VERSION:-3.0.1}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.gz
+cd $PRGNAM-$VERSION
+chown -R root:root .
+
+PREFIX=/opt/lxd
+
+mkdir -p $PKG/$PREFIX/bin
+export GOPATH=$TMP/$PRGNAM-$VERSION/dist
+go build -o $PKG$PREFIX/bin/lxd github.com/lxc/lxd/lxd
+go build -o $PKG$PREFIX/bin/lxc github.com/lxc/lxd/lxc
+go build -o $PKG$PREFIX/bin/fuidshift github.com/lxc/lxd/fuidshift
+go build -o $PKG$PREFIX/bin/lxd-p2c github.com/lxc/lxd/lxd-p2c
+cp -a scripts/lxc-to-lxd $PKG/$PREFIX/bin
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/man/man1
+help2man $PKG$PREFIX/bin/lxd -n "The container hypervisor - daemon" --no-info --no-discard-stderr > $PKG/usr/man/man1/lxd.1
+help2man $PKG$PREFIX/bin/lxc -n "The container hypervisor - client" --no-info --no-discard-stderr > $PKG/usr/man/man1/lxc.1
+help2man $PKG$PREFIX/bin/fuidshift -n "uid/gid shifter" --no-info --no-discard-stderr > $PKG/usr/man/man1/fuidshift.1
+help2man $PKG$PREFIX/bin/lxd-p2c -n "uid/gid shifter" --no-info --no-discard-stderr > $PKG/usr/man/man1/lxd-p2c.1
+
+find $PKG/usr/man -type f -exec gzip -9 {} \;
+for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+
+install -D -m0755 $CWD/service-log-lxd-run $PKG$PREFIX/service/log/run.new
+install -D -m0755 $CWD/service-lxd-run $PKG$PREFIX/service/run.new
+
+install -D -m0755 $CWD/etc-profile-d-lxd.sh $PKG/etc/profile.d/lxd.sh.new
+install -D -m0755 $CWD/etc-profile-d-lxd.csh $PKG/etc/profile.d/lxd.csh.new
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ AUTHORS COPYING README.md contributing.md \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/system/lxd/lxd.info b/system/lxd/lxd.info
new file mode 100644
index 0000000000..2620e5a94b
--- /dev/null
+++ b/system/lxd/lxd.info
@@ -0,0 +1,10 @@
+PRGNAM="lxd"
+VERSION="3.0.1"
+HOMEPAGE="https://linuxcontainers.org"
+DOWNLOAD="https://linuxcontainers.org/downloads/lxd/lxd-3.0.1.tar.gz"
+MD5SUM="63f5937605f9ba861b4c5f617171920b"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="google-go-lang"
+MAINTAINER="Vasco Santos"
+EMAIL="valexsantos_at_gmail_dot_com"
diff --git a/system/lxd/service-log-lxd-run b/system/lxd/service-log-lxd-run
new file mode 100644
index 0000000000..61fa33517d
--- /dev/null
+++ b/system/lxd/service-log-lxd-run
@@ -0,0 +1,43 @@
+#!/bin/bash
+
+# generic daemontools log run script
+
+# Copyright 2017-2018 Vasco Santos <valexsantos[at]gmail[dot]com>
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ''AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+#
+# cfgs
+#
+LOGUSER=lxd
+LOGDIR=/var/log/$LOGUSER
+LOG_FILE_HISTORY=20
+LOG_FILE_SIZE=100000
+##
+# doit
+##
+PATH=/opt/daemontools/bin:/usr/local/bin:/usr/bin:/bin
+export PATH
+# create log dir
+[ -d $LOGDIR ] || mkdir $LOGDIR
+# set owner
+chown -R $LOGUSER $LOGDIR
+# go
+exec 2>&1
+exec setuidgid $LOGUSER multilog t s$LOG_FILE_SIZE n$LOG_FILE_HISTORY $LOGDIR
diff --git a/system/lxd/service-lxd-run b/system/lxd/service-lxd-run
new file mode 100644
index 0000000000..622a6ae5cb
--- /dev/null
+++ b/system/lxd/service-lxd-run
@@ -0,0 +1,55 @@
+#!/bin/bash
+
+# lxd daemontools run script
+
+# Copyright 2017-2018 Vasco Santos <valexsantos[at]gmail[dot]com>
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ''AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+exec 2>&1
+
+PATH="/usr/local/bin:/usr/bin:/bin:/sbin:/usr/sbin:/opt/daemontools/bin:/opt/lxd/bin"
+#
+# systemd support
+if [ ! -d /sys/fs/cgroup/systemd ]; then
+ echo "mounting systemd support...."
+ mkdir /sys/fs/cgroup/systemd
+ mount -t cgroup -o rw,nosuid,nodev,noexec,relatime,none,name=systemd cgroup /sys/fs/cgroup/systemd
+fi
+
+CMD="lxd daemon --group=lxd"
+echo "command-line $CMD"
+
+##
+# Doit
+##
+ulimit -f unlimited
+ulimit -t unlimited
+ulimit -v unlimited
+ulimit -n 819200
+ulimit -m unlimited
+ulimit -u 819200
+
+exec $CMD
+
+##
+# err
+echo ERROR: command did not run correctly
+sleep 5
+exit 1
diff --git a/system/lxd/slack-desc b/system/lxd/slack-desc
new file mode 100644
index 0000000000..4cc4ea1907
--- /dev/null
+++ b/system/lxd/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+lxd: lxd (container hypervisor for lxc)
+lxd:
+lxd: LXD is a container "hypervisor" and a new user experience for LXC.
+lxd:
+lxd: Homepage: https://linuxcontainers.org
+lxd:
+lxd:
+lxd:
+lxd:
+lxd:
+lxd: